package com.gic.haoban.manage.service.dao.mapper;

import java.util.Date;
import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.github.pagehelper.Page;

public interface TabHaobanExternalClerkRelatedMapper {
    int deleteByPrimaryKey(String externalClerkRelatedId);

    int insert(TabHaobanExternalClerkRelated record);

    int insertSelective(TabHaobanExternalClerkRelated record);

    TabHaobanExternalClerkRelated selectByPrimaryKey(String externalClerkRelatedId);

    int updateByPrimaryKeySelective(TabHaobanExternalClerkRelated record);

    int updateByPrimaryKey(TabHaobanExternalClerkRelated record);

	TabHaobanExternalClerkRelated selectByClerkIdAndExternalUserId(@Param("clerkId")String clerkId, @Param("externalUserId")String externalUserId);

	void delByUserIdAndExternalUserId(TabHaobanExternalClerkRelated record);

	void delByUserIdAndExternalUserIdBatch(@Param("wxUserId") String wxUserId, @Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserIds") List<String> externalUserIds);

	void delByClerkIdAndStaffId(@Param("clerkId")String clerkId, @Param("staffId")String staffId);

	void cleanStaffRelated(@Param("wxEnterpriseId")String wxEnterpriseId, @Param("staffIds")List<String> staffIds);

	TabHaobanExternalClerkRelated getByParams(@Param("userId")String userId, @Param("wxEnterpriseId")String wxEnterpriseId, @Param("name")String name, @Param("createTime")String createTime);

	List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserId(@Param("externalUserid")String externalUserid, @Param("userId")String wxUserId);
	
	List<TabHaobanExternalClerkRelated> listByEnterpriseIdAndDate(@Param("enterpriseId")String enterpriseId,@Param("date")Date date);

	Page<TabHaobanExternalClerkRelated> pageMemberUnionByParams(@Param("userIdList")List<String> userIdList, @Param("sendMemberIds")List<String> sendMemberIds,
			@Param("enterpriseId")String enterpriseId);

	List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserId(@Param("wxUserId")String wxUserId, @Param("wxEnterpriseId")String wxEnterpriseId);

	List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserIds(@Param("userIdList")List<String> userIdList, @Param("wxEnterpriseId")String wxEnterpriseId);

	TabHaobanExternalClerkRelated getByMemberId(@Param("wxUserId")String wxUserId, @Param("memberId")String memberId);

    /**
     * 外部联系人的unionid
     *
     * @param enterpriseId
     * @param unionId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listExternalByUnionId(@Param("enterpriseId") String enterpriseId, @Param("unionId") String unionId);

    /**
     * @param relationKey
     * @return
     */
    TabHaobanExternalClerkRelated getByRelationKey(@Param("relationKey") String relationKey);

	/**
	 * 列表数据 根据状态 时间倒序
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param statusFlag
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserIdAndStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("wxUserId") String wxUserId, @Param("statusFlag") Integer statusFlag);

	/**
	 * 触达会员 给会员发送
	 *
	 * @param relationKey
	 * @return
	 */
	TabHaobanExternalClerkRelated pushExternalByRelationKey(@Param("relationKey") String relationKey);

	/**
	 * 获取企业下的关联关系列表
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param enterpriseId
	 * @param externalUserId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listExternalClerkByWxUserIdAncExternalUserId(String wxEnterpriseId, String wxUserId, String enterpriseId, String externalUserId);



}